invoice-de/src/main/java/com/camunda/fox/showcase/invoice/de/ApproveInvoiceController.java
package com.camunda.fox.showcase.invoice.de;

import javax.enterprise.inject.Model;
import javax.inject.Inject;

import org.activiti.cdi.BusinessProcess;

@Model
public class ApproveInvoiceController {

  private boolean approved;

  @Inject
  private BusinessProcess businessProcess;

  public boolean isApproved() {
    return approved;
  }

  public void setApproved(boolean approved) {
    this.approved = approved;
    businessProcess.setVariable("approved", approved);
  }
}

invoice-de/src/main/java/com/camunda/fox/showcase/invoice/de/servlet/ProcessDiagramServlet.java
package com.camunda.fox.showcase.invoice.de.servlet;

import java.io.IOException;
import java.io.InputStream;

import javax.inject.Inject;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.activiti.engine.RepositoryService;
import org.activiti.engine.TaskService;
import org.activiti.engine.task.Task;
import org.apache.commons.io.IOUtils;

import com.camunda.fox.showcase.invoice.de.tasklist.ProcessDiagramController;


@WebServlet(value = "/processDiagram", loadOnStartup = 1)
public class ProcessDiagramServlet extends HttpServlet {

  private static final long serialVersionUID = 1L;

  @Inject
  private RepositoryService repositoryService;
  
  @Override
  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {    
    String processDefinitionId = request.getParameter("processDefinitionId");    
    InputStream processDiagram = repositoryService.getProcessDiagram(processDefinitionId);

    response.setContentType("image/png");
    response.getOutputStream().write(IOUtils.toByteArray(processDiagram));
  }
}

invoice-de/src/main/java/com/camunda/fox/showcase/invoice/de/tasklist/ProcessDiagramController.java
package com.camunda.fox.showcase.invoice.de.tasklist;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.activiti.cdi.BusinessProcess;
import org.activiti.engine.HistoryService;
import org.activiti.engine.RepositoryService;
import org.activiti.engine.RuntimeService;
import org.activiti.engine.history.HistoricActivityInstance;
import org.activiti.engine.repository.DiagramLayout;
import org.activiti.engine.repository.DiagramNode;
import org.activiti.engine.runtime.ProcessInstance;


@Named
public class ProcessDiagramController {

  @Inject
  private RuntimeService runtimeService;

  @Inject
  private RepositoryService repositoryService;

  @Inject
  private HistoryService historyService;

  @Inject
  private BusinessProcess businessProcess;

  private ProcessInstance getCurrentProcessInstance() {
    return businessProcess.getProcessInstance();
  }

  public List<PositionedHistoricActivityInstance> getTraversedFlowNodes() {
    ArrayList<PositionedHistoricActivityInstance> alist = new ArrayList<PositionedHistoricActivityInstance>();

    ProcessInstance processInstance = getCurrentProcessInstance();

    if (processInstance != null) {
      DiagramLayout processDiagramLayout = repositoryService.getProcessDiagramLayout(processInstance.getProcessDefinitionId());

      List<HistoricActivityInstance> hlist = historyService.createHistoricActivityInstanceQuery().processInstanceId(processInstance.getId()).list();

      for (HistoricActivityInstance hact : hlist) {
        if (hact.getEndTime() != null) {
          PositionedHistoricActivityInstance pact = new PositionedHistoricActivityInstance(hact, processDiagramLayout.getNode(hact.getActivityId()));
          alist.add(pact);
        }
      }
    }

    return alist;
  }

  public List<DiagramNode> getActiveActivityBoundsOfLatestProcessInstance() {
    ArrayList<DiagramNode> list = new ArrayList<DiagramNode>();
    ProcessInstance processInstance = getCurrentProcessInstance();
    if (processInstance != null) {
      DiagramLayout processDiagramLayout = repositoryService.getProcessDiagramLayout(processInstance.getProcessDefinitionId());
      List<String> activeActivityIds = runtimeService.getActiveActivityIds(processInstance.getId());
      for (String activeActivityId : activeActivityIds) {
        list.add(processDiagramLayout.getNode(activeActivityId));
      }
    }
    return list;
  }

}

invoice-de/src/main/java/com/camunda/fox/showcase/invoice/de/tasklist/TaskListController.java
package com.camunda.fox.showcase.invoice.de.tasklist;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.activiti.engine.FormService;
import org.activiti.engine.IdentityService;
import org.activiti.engine.TaskService;
import org.activiti.engine.identity.Group;
import org.activiti.engine.identity.User;
import org.activiti.engine.task.Task;

import com.camunda.fox.showcase.invoice.de.ProcessConstants;

@Named
@SessionScoped
public class TaskListController implements Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  private TaskService taskService;

  @Inject
  private FormService formService;

  @Inject
  private IdentityService identityService;

  private String currentUser = "kermit";

  private String currentGroup;

  private String currentDemoProcess = ProcessConstants.PROCESS_NAME_FOX;

  public long getPersonalTaskListCount() {
    return taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskAssignee(currentUser).count();
  }

  public long getGroupTaskListCount(String role) {
    return taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskCandidateGroup(role).count();
  }

  public List<Task> getTaskList() {
    if (currentGroup == null || currentGroup.length() == 0) {
      return taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskAssignee(currentUser).list();
    } else {
      return taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskCandidateGroup(currentGroup).list();
    }
  }

  public boolean isHasTasks() {
    if (currentGroup == null || currentGroup.length() == 0) {
      if (taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskAssignee(currentUser).count() == 0) {
        return false;
      } else {
        return true;
      }
    } else {
      if (taskService.createTaskQuery().processDefinitionKey(currentDemoProcess).taskCandidateGroup(currentGroup).count() == 0) {
        return false;
      } else {
        return true;
      }
    }
  }

  public List<String> getCurrentUserInfoKeys() {
    return identityService.getUserInfoKeys(currentUser);
  }

  public String getCurrentUserInfo(String key) {
    return identityService.getUserInfo(currentUser, key);
  }

  public List<User> getUsersList() {
    return identityService.createUserQuery().list();
  }
  
  public List<String> getDemoProcessesList() {
    ArrayList<String> list = new ArrayList<String>();
    list.add(ProcessConstants.PROCESS_NAME_FOX);
    list.add(ProcessConstants.PROCESS_NAME_ADONIS);
    return list;
  }
  
  public List<Group> getGroupsList() {
    return identityService.createGroupQuery().groupMember(currentUser).list();
  }

  public void setCurrentGroup(String currentGroup) {
    this.currentGroup = currentGroup;
  }

  public String getCurrentGroup() {
    return currentGroup;
  }

  public String getFormKey(Task task) {
    return formService.getTaskFormData(task.getId()).getFormKey();
  }

  public void claim(Task task) {
    taskService.claim(task.getId(), currentUser);
  }

  public void setCurrentUser(String currentUser) {
    this.currentUser = currentUser;
  }

  public String getCurrentUser() {
    return currentUser;
  }

  
  public String getCurrentDemoProcess() {
    return currentDemoProcess;
  }

  
  public void setCurrentDemoProcess(String currentDemoProcess) {
    this.currentDemoProcess = currentDemoProcess;
  }
}

invoice-de/src/main/webapp/WEB-INF/templates/taskTemplate.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="template.xhtml">
	<ui:define name="content">
      	  <ui:insert name="metadata"/>

		<table>
			<tr>
			<td><img width="50" src="./userPicture?user=#{taskListController.currentUser}"/></td>
			<td style="vertical-align:top;">
				<strong>#{businessProcess.task.name}</strong><br/>
				#{businessProcess.task.description}
			</td>
			</tr>			
		</table>


		<div id="accordion">
			<div>
				<h3><a href="#">Formular</a></h3>
				<div>
					<h:form>
       					<ui:insert name="form">here we will see the form</ui:insert>
						<h:commandButton action="#{businessProcess.completeTask(true)}" value="OK" />
					</h:form>
				</div>
			</div>
			<div>
				<h3><a href="#">Beleg als PDF</a></h3>
				<div><a target="_blank" href="./downloadInvoice?taskId=#{taskId}">PDF anzeigen</a></div>
			</div>
			<div>
				<h3><a href="#">Wo stehe ich im Prozess?</a></h3>			
	     	   <div style="padding:0px !important;"><div position="relative">
	     	       <img src="processDiagram?processDefinitionId=#{task.processDefinitionId}" style="padding-left:2px;" />
		 	   		<ui:repeat value="#{processDiagramController.getActiveActivityBoundsOfLatestProcessInstance()}" var="bounds">
				       <img src="token.png" style="
				         position: absolute;
				         left: #{bounds.x + bounds.width - 25}px;
				         top: #{bounds.y - 15}px;
				         z-index: 1;
				         "/>

	    			</ui:repeat>			

		 	   		<ui:repeat value="#{processDiagramController.getTraversedFlowNodes()}" var="pact">
				       <img src="htoken.png" style="
				         position: absolute;
				         left: #{pact.bounds.x + pact.bounds.width - 20}px;
				         top: #{pact.bounds.y - 10}px;
				         z-index: 0;
				         "/>
					     <div class="highlight_#{pact.hact.activityId}" style="
					       cursor: pointer;
					       position: absolute;
					       left: #{pact.bounds.x}px;
					       top: #{pact.bounds.y}px;
					       width: #{pact.bounds.width}px;
					       height: #{pact.bounds.height}px;
					       /*border: 2px solid rgb(181, 21, 43);
					       background: rgba(181, 21, 43, 0.1);
					       border-radius: 5px; -moz-border-radius: 5px;*/"></div>
	       
						   <div id="dialog_#{pact.hact.activityId}" title="Details">
						      <table><tr>
						       <td>Aufgabe: </td><td>#{pact.hact.activityName}</td></tr>
						       <tr><td>Abgearbeitet von: </td><td>#{pact.hact.assignee}</td></tr>
						       <tr><td>Beauftragt: </td><td>
						       <h:outputText value="#{pact.hact.startTime}" >
						       		<f:convertDateTime pattern="dd.MM.yyyy HH:mm" timeZone="Europe/Berlin" /> 
						 	    </h:outputText>
						 	    Uhr
						 	    </td></tr>
						       <tr><td>Beendet: </td><td>
						        <h:outputText value="#{pact.hact.endTime}" >
						       		<f:convertDateTime pattern="dd.MM.yyyy HH:mm" timeZone="Europe/Berlin"  /> 
						 	    </h:outputText>
						 	    Uhr
						       </td></tr>
						       <tr><td>Durchlaufzeit: </td><td>
						       
						         <h:outputText value="#{pact.hact.durationInMillis}" >
						       		<f:convertDateTime pattern="HH:mm:ss" type="time" /> 
						 	    </h:outputText>
						       </td></tr>
						      </table>
						    </div>
					          <script>
					        $(document).ready(function() {
					
					        $("#dialog_#{pact.hact.activityId}").dialog({ autoOpen: false, modal: false, resizable: false, width: 450 });
					
					        $(".highlight_#{pact.hact.activityId}").click(function() {
					          var x = $(this).position().left;
					          var y = $(this).position().top - $(document).scrollTop() + 100;
					          $("#dialog_#{pact.hact.activityId}").dialog('option', 'position', [x,y]);
					          $('#dialog_#{pact.hact.activityId}').dialog('open');
					        });
					
					      });
					    </script>
	       
	    			</ui:repeat>


	    			</div>
	     	   </div>
			</div>
		</div>
	</ui:define>
</ui:composition>

invoice-de/src/main/webapp/WEB-INF/templates/template.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets">
<h:head>
	<title>Demo: Rechnungseingang</title>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<h:outputStylesheet name="css/start/jquery-ui-1.8.16.custom.css" />
	<h:outputStylesheet name="css/start/demo_page.css" />
	<h:outputStylesheet name="css/start/demo_table.css" />
	<h:outputStylesheet name="css/start/demo_table_jui.css" />
	<h:outputStylesheet name="css/start/camunda.css" />

			<style type="text/css">
			/*demo page css*/
			body{ font: 80% "Trebuchet MS", sans-serif; margin: 50px;}
			.demoHeaders { margin-top: 2em; }
			#dialog_link {padding: .4em 1em .4em 20px;text-decoration: none;position: relative;}
			#dialog_link span.ui-icon {margin: 0 5px 0 0;position: absolute;left: .2em;top: 50%;margin-top: -8px;}
			ul#icons {margin: 0; padding: 0;}
			ul#icons li {margin: 2px; position: relative; padding: 4px 0; cursor: pointer; float: left;  list-style: none;}
			ul#icons span.ui-icon {float: left; margin: 0 4px;}
		</style>	
	<h:outputScript name="js/jquery-1.6.2.min.js"/>
	<h:outputScript name="js/jquery-ui-1.8.16.custom.min.js"/>
	<h:outputScript name="js/jquery.ui.datepicker-de.js"/>
	<h:outputScript name="js/jquery.dataTables.min.js"/>

	
	 <script type="text/javascript">                                         
		$(function(){

			// Accordion
			$( "#accordion" ).accordion({ 
				header: "h3", 
				autoHeight: false,	
				navigation: true
			});
			// Tabs
			$( "#tabs" ).tabs({
				ajaxOptions: {
					error: function( xhr, status, index, anchor ) {
						$( anchor.hash ).html(
							"Couldn't load this tab. We'll try to fix this as soon as possible. " +
							"If this wouldn't be a demo." );
					}
				}
			});			

			// Dialog			
			$('#dialog').dialog({
				autoOpen: false,
				width: 600,
				buttons: {
					"Ok": function() { 
						$(this).dialog("close"); 
					}, 
					"Cancel": function() { 
						$(this).dialog("close"); 
					} 
				}
			});
			
			// Dialog Link
			$('#dialog_link').click(function(){
				$('#dialog').dialog('open');
				return false;
			});

			// Datepicker
			$('#datepicker').datepicker({
				inline: true
			});
			
			// Slider
			$('#slider').slider({
				range: true,
				values: [17, 67]
			});
			
			// Progressbar
			$("#progressbar").progressbar({
				value: 20 
			});
			
			//hover states on the static widgets
			$('#dialog_link, ul#icons li').hover(
				function() { $(this).addClass('ui-state-hover'); }, 
				function() { $(this).removeClass('ui-state-hover'); }
			);
			
		});
	 </script>
</h:head>
<h:body>

	<h:panelGroup id="page" layout="block">
		<h:panelGroup id="header">			
			<h1>Demo: Rechnungseingang</h1>					
		</h:panelGroup>

		<h:panelGroup>
			<h:form>
				<h:outputLink value="taskList.jsf">Tasklist</h:outputLink> | 			
				<h:outputLink value="startwas.jsf">Starten</h:outputLink> | 			
				<h:outputLink value="myuser.jsf">User-Infos</h:outputLink>  			
			</h:form>			
		</h:panelGroup>	
		<hr />	
		<h:panelGroup id="container" layout="block">		
			<h:panelGroup>	
				<h:panelGroup id="content" layout="block">
					<h:messages globalOnly="true"/>
					<ui:insert name="content">Main Content</ui:insert>
				</h:panelGroup>
			</h:panelGroup>
			<h:panelGroup id="footer" layout="block">
				<hr />
				powered by <a href="http://www.camunda.com/fox">camunda fox</a>
			</h:panelGroup>
		</h:panelGroup>		
	</h:panelGroup>

</h:body>
</html>

invoice-de/src/main/webapp/assignApprover.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="WEB-INF/templates/taskTemplate.xhtml">
	
	    <ui:define name="metadata">
	    
	   	<f:metadata>
			<f:viewParam name="taskId"></f:viewParam>
			<f:viewParam name="form"></f:viewParam>
			<f:event listener="#{businessProcess.startTask(taskId,true)}" type="preRenderView"></f:event>
		</f:metadata>
	</ui:define>
	
	<ui:define name="form">
	<table class="cam-form">
		<tr>
			<td>Kreditor: </td>
			<td><h:inputText id="creditor" value="#{processVariables['creditor']}" size="40" maxlength="100" required="true" requiredMessage="Pflichtfeld!"/></td>
			<td class="validationError">
				<h:message for="creditor"/>
			</td>
		</tr>
		<tr>
			<td>Rechnungsdatum: </td>
			<td><h:inputText id="date" value="#{processVariables['invoice_date']}" required="true" requiredMessage="Pflichtfeld!" >
				<f:convertDateTime pattern="dd.MM.yyyy"/>
			</h:inputText>
			
			</td>
			<td class="validationError">
				<h:message for="date"/>
			</td>			
	 <script type="text/javascript">                                         
		$('#j_idt35\\:date').datepicker({
			showAnim: 'slide'
		});

	 </script>
		</tr>
		<tr>
			<td>Freigebender:</td>
			<td>
				<h:selectOneMenu value="#{processVariables['approver']}">
					<f:selectItems value="#{taskListController.usersList}" var="v_user" 
					itemLabel="#{v_user.id}" itemValue="#{v_user.id}"></f:selectItems>
				</h:selectOneMenu><br/>
			</td>
		</tr>				
		<tr>
			<td>Hinweise:</td>
			<td><h:inputTextarea value="#{processVariables['comment']}" cols="30" rows="5"/></td>
		</tr>
	</table>

	</ui:define>

</ui:composition>

invoice-de/src/main/webapp/clarifyInvoice.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="WEB-INF/templates/taskTemplate.xhtml">
	
	    <ui:define name="metadata">
	    
	   	<f:metadata>
			<f:viewParam name="taskId"></f:viewParam>
			<f:viewParam name="form"></f:viewParam>
			<f:event listener="#{businessProcess.startTask(taskId,true)}" type="preRenderView"></f:event>
		</f:metadata>
	</ui:define>
	
	<ui:define name="form">
	<table class="cam-form">
		<tr>
			<td>Ergebnis der Kl&#228;rung: </td>
			<td>
				<h:selectOneMenu value="#{processVariables['clarified']}">
					<f:selectItem itemValue="yes" itemLabel="Erneut freizugeben"/>
					<f:selectItem itemValue="no" itemLabel="Rechnung verwerfen"/>
				</h:selectOneMenu>
			</td>
		</tr>

		<tr>
			<td>Neuer Freigebender:</td>
			<td>
				<h:selectOneMenu value="#{processVariables['approver']}">
					<f:selectItems value="#{taskListController.usersList}" var="v_user" 
					itemLabel="#{v_user.id}" itemValue="#{v_user.id}"></f:selectItems>
				</h:selectOneMenu><br/>
			</td>
		</tr>				
		<tr>
			<td>Hinweise:</td>
			<td><h:inputTextarea value="#{processVariables['comment']}" cols="30" rows="5"/></td>
		</tr>
	</table>
	</ui:define>

</ui:composition>

invoice-de/src/main/webapp/myuser.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="WEB-INF/templates/template.xhtml">
	<ui:define name="content">
<h1>#{taskListController.currentUser}</h1>
<table>
<tr><td>
				<img src="./userPicture?user=#{taskListController.currentUser}" style="float:left; margin-right:20px;"/>
</td>
<td>
				<table>				
				<ui:repeat var="infoKey" value="#{taskListController.currentUserInfoKeys}">
					<tr>
						<td><strong>#{infoKey}:</strong></td>
						<td>#{taskListController.getCurrentUserInfo(infoKey)}</td>
					</tr>
				</ui:repeat>
				</table>
</td></tr></table>
	</ui:define>
</ui:composition>

invoice-de/src/main/webapp/taskList.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	template="WEB-INF/templates/template.xhtml">
	<ui:define name="content">
		<h:form>
		<!--  User Switch -->
		<table>
			<tr>
			<td><img width="50" src="./userPicture?user=#{taskListController.currentUser}"/></td>
			<td style="vertical-align:top;">
				Demo-Prozess:<br/>
				<h:selectOneMenu value="#{taskListController.currentDemoProcess}">
					<f:selectItems value="#{taskListController.demoProcessesList}" var="demoProcess" itemLabel="#{demoProcess}" itemValue="#{demoProcess}"></f:selectItems>
					<f:ajax render="@form" ></f:ajax>
				</h:selectOneMenu><br/>			
				Demo-User:<br/>
				<h:selectOneMenu value="#{taskListController.currentUser}">
					<f:selectItems value="#{taskListController.usersList}" var="v_user" itemLabel="#{v_user.id}" itemValue="#{v_user.id}"></f:selectItems>
					<f:ajax render="@form" ></f:ajax>
				</h:selectOneMenu><br/>			
			</td>
			</tr>			
		</table>
		<!--  List Switch -->
		<h:panelGrid columns="2" columnClasses="cam-td, cam-td-2">
				<h:panelGroup>
				<h2>Task-Listen</h2>
					<ul>
						<li>
							<h:commandLink action="#{taskListController.setCurrentGroup(null)}" value="Meine Aufgaben (#{taskListController.personalTaskListCount})">
								<f:ajax render="@form" />
							</h:commandLink>
						</li>
					 </ul>
					 <ul>
						<ui:repeat var="group" value="#{taskListController.groupsList}">
							<li>
								<h:commandLink action="#{taskListController.setCurrentGroup(group.id)}" value="#{group.name} (#{taskListController.getGroupTaskListCount(group.id)})">
									<f:ajax render="@form" />
								</h:commandLink>
							</li>					
						</ui:repeat>
					</ul>								
				</h:panelGroup>
				<h:panelGroup >
					<h:panelGroup rendered="#{!taskListController.currentGroup.equals('')}">
						<h2>Aufgaben f&#252;r #{taskListController.currentGroup}</h2>
					</h:panelGroup>
					<h:panelGroup rendered="#{taskListController.currentGroup.equals('')}">
						<h2>Meine Aufgaben (#{taskListController.currentUser})</h2>
					</h:panelGroup>
					<h:panelGroup rendered="#{!taskListController.hasTasks}">
						<div class="ui-widget">
							<div class="ui-state-highlight ui-corner-all" style="margin-top: 20px; padding: 0 .7em;"> 
								<p><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em; "></span>
								<strong>Nix zu tun!</strong> Entspann Dich.</p>
							</div>
						</div>
					</h:panelGroup>
		<!--  Actual Task List -->					
					<h:dataTable width="800px" id="tasklist" value="#{taskListController.taskList}" var="task" rendered="#{taskListController.hasTasks}">
						<h:column>
							<f:facet name="header">Id</f:facet>
							#{task.id}
						</h:column>
						<h:column>
							<f:facet name="header">Aufgabe</f:facet>
							#{task.name}
						</h:column>	
						<h:column>
							<f:facet name="header">Beschreibung</f:facet>
							#{task.description}
						</h:column>	
						<h:column>
							<f:facet name="header">Aufgabe erhalten</f:facet>
							 <h:outputText value="#{task.createTime}" >
              					<f:convertDateTime pattern="dd.MM.yyyy HH:mm" /> 
 							 </h:outputText>
							 Uhr
						</h:column>
						<h:column>
							<f:facet name="header">Deadline</f:facet>
						</h:column>
						<h:column>
							<f:facet name="header">Aktion</f:facet>							
							<h:outputLink 
								rendered="#{task.assignee eq taskListController.currentUser}"
								value="#{taskListController.getFormKey(task)}.jsf?taskId=#{task.id}">bearbeiten...</h:outputLink>
							<h:commandLink 
								rendered="#{task.assignee != taskListController.currentUser}"
								action="#{taskListController.claim(task)}"
								value="claim">
								<f:ajax render="@form" />	
							</h:commandLink>
						</h:column>					
					</h:dataTable>
					</h:panelGroup>

<!-- some layouting and javascript for the table -->
	 <script type="text/javascript">                                         
	 $(document).ready(function() {
			    oTable = $('#j_idt32\\:tasklist').dataTable({
			        "bJQueryUI": true,
			        "bPaginate": true
			    });

	 } );
  	 var processEvent = function processEvent(data) {
     }		
  	 jsf.ajax.addOnEvent(processEvent);
	 </script>
				
			</h:panelGrid>
		</h:form>
	</ui:define>
</ui:composition>